<?php

/*
 *   This file is part of PhpCompta.
 *
 *   PhpCompta is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   PhpCompta is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with PhpCompta; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
// Copyright (2014) Author Dany De Bontridder <dany@alchimerys.be>

/**
 * @file
 * @brief save condition
 */
if (!defined('ALLOWED'))
    die('Appel direct ne sont pas permis');
/**
 * @var $http HttpInput inherited
 * @var $cn Database inherited
 * @var $g_listing_home string inherited
 */
require $g_listing_home.'/include/rapav_condition.class.php';


$lc_id=$http->request('lc_id','number');
$lp_id=$http->request('lp_id','number');
$c_value=$http->request('c_value','string');
$c_operator=$http->request('c_operator','string');

$cond=new RAPAV_Condition($lc_id);
$cond->set_value($c_value);
$cond->set_operator($c_operator);
$cond->set_listing_param($lp_id);
$cond->save();

?>
