<?php
//This file is part of NOALYSS and is under GPL 
//see licence.txt

/**
 * @var $http HttpInput inherited
 * @var $cn Database inherited
 * @var $g_listing_home string inherited
 */

require_once $g_listing_home.'/include/rapav_listing_compute.class.php';
$p_from =$http->request('p_from');
$p_subject =$http->request('p_subject');
$p_message=$http->request('p_message');
//var $lc_id int listing_compute.lc_id
$lc_id=$http->request('lc_id');
$p_attach=$http->request('p_attach');
$checkbox_message=$http->request('checkbox_message','string',0);

ob_start();
$listing=new RAPAV_Listing_Compute();
$listing->load($lc_id);
$tcopy=(isset($_REQUEST['copy']))?1:0;
$error="";
echo HtmlInput::title_box(_('Résultat'),'parameter_send_mail_result');


try {
    $file_to_send=$listing->export_attached_file();
    $a_result=$listing->send_mail($p_from,$p_subject,$p_message,$p_attach,$tcopy,$file_to_send);

    // save message into listing.listing_mail_message
    if ($checkbox_message == 1 ) {
        $listing_id=$cn->get_value('select l_id from rapport_advanced.listing_compute where lc_id=$1',[$lc_id]);
        $cn->exec_sql('insert into rapport_advanced.listing_mail_message(lm_subject,lm_message,listing_id)
values ($1,$2,$3)',
        [$p_subject,$p_message,$listing_id]);
        echo '<span class="notice">',_('Message sauvé').'</span>';
    }
    echo '<ol>';
    for ($i=0;$i<count($a_result);$i++)
    {
        echo '<li>'.$a_result[$i].'</li>';
    }
    echo '</ol>';
} catch (\Exception $e) {
    printf(_("Email non envoyé "));
    echo_warning($e->getMessage());
}
echo HtmlInput::button_close('parameter_send_mail_result');
$response = ob_get_clean();
$html = escape_xml($response);
header('Content-type: text/xml; charset=UTF-8');
echo <<<EOF
<?xml version="1.0" encoding="UTF-8"?>
<data>
<ctl></ctl>
<code>$html</code>
</data>
EOF;
?>        