<?php
//This file is part of NOALYSS and is under GPL 
//see licence.txt
/**
 * @var $cn \Database conx to folder
 */
global $tab;
$http=new \HttpInput();
$display="hidden";
if ( DEBUGNOALYSS>1) $display="block";
/**
 *@brief  show parameter_chld. example
 *
 * @code
 * echo show("GRIL00",_("Grille 00 : opérations soumises à un régime particulier"))
 * @endcode
 *
 *@parameter $p_code is the GRID  code)
 *@parameter $p_desc is the label
 */
function show($p_code,$p_desc) {
	global $cn,$tab,$dossier;


    $http=new \HttpInput();
	echo "<h2>".h($p_code)." ".$p_desc."</h2>";
	$plugin_code=$http->request('plugin_code');
	$dossier=\Dossier::id();
	$a_code=$cn->get_array(\Belgian_Tax\Parameter\Tva_Parameter::SQL_DETAIL_ROW.
        "			where pcode=$1 order by pi_id",
			array($p_code));
	$n_max=sizeof($a_code);
	echo "<table class=\"result\" id='list_{$p_code}'>";
	echo "<tr>";
	echo th("Code TVA");
	echo th("Label");
	echo th("Description");
	echo th("Taux");
	echo th("Signe");
	echo th("Opération");
	echo th("utilisant le poste comptable");
	echo th("pour le journal");
	echo "</tr>";
	for ($i=0;$i<$n_max;$i++)
	{
		echo \Belgian_Tax\Parameter\Tva_Parameter::print_row($p_code,$plugin_code,$a_code[$i]);
	}
	echo "</table>";
	echo \HtmlInput::button("add_param","Ajout paramètre","onclick=\"show_addparam('$p_code','$plugin_code','$dossier','$tab');\"");
}
$current_url=array ('gDossier'=>$http->request("gDossier","number"),
    'ac'=>$http->request("ac" ),
    'plugin_code'=>$http->request("plugin_code" ),
    'sa'=>$http->request("sa","string","" )
    );
$x=$current_url;$x['tab']='code_grille';
$code_grille=http_build_query($x);
$y=$current_url;$y['tab']='summary_vat';
$summary_vat=http_build_query($y);
?>
<?php 
	$tab_default=$http->request('tab','string','opout');
?>
<ul class="tabs noprint">

<li class="tabs" id="tab_representative"><a onclick="tva_show_param('representative')">Représentant - Déclarant</a></li>
<li class="tabs" id="tab_opout"><a onclick="tva_show_param('opout')">Opération à la sortie</a></li>
<li class="tabs" id="tab_opin"><a style="" onclick="tva_show_param('opin')">Opération à l'entrée </a></li>
<li class="tabs" id="tab_tvadue"><a onclick="tva_show_param('tvadue')">TVA Due</a></li>
<li class="tabs" id="tab_tvaded"><a onclick="tva_show_param('tvaded')">TVA Déductible</a></li>
<li class="tabs" id="tab_code_grille"><a href="do.php?<?=$code_grille?>">TVA et grilles </a></li><li class="tabs" id="tab_summary_vat"><a href="do.php?<?=$summary_vat?>">Résumé formulaire </a></li>
<li class="tabs" id="tab_lintra"><a onclick="tva_show_param('lintra')">Listing Client Intracomm.</a></li>
<li class="tabs" id="tab_assujetti"><a onclick="tva_show_param('assujetti')">Listing Client assujetti.</a></li>
<li class="tabs" id="tab_confg"><a onclick="tva_show_param('confg')">Configuration</a>
<li class="tabs" id="tab_divers"><a onclick="tva_show_param('divers')">Divers</a>
</ul>

<div style="clear:both"></div>

<form method="POST" class="print">
    <?php
    echo \HtmlInput::hidden('tab',$tab_default);
    echo \HtmlInput::request_to_hidden(array('gDossier','ac','plugin_code','sa'));
    ?>
    <div style="display:<?= $display ?>>" id="representative"  class="p-2">

        <?php
        echo \HtmlInput::request_to_hidden(["gDossier", "ac", "plugin_code", "sa"]);
        echo \HtmlInput::hidden("save_info_repdecl", "1");
        ?>
        <div class="row">

            <div class="col">
                <h2>Représentant</h2>
                <?php
                $representative = new \Belgian_Tax\XML\Representative();
                $representative->input();

                ?>
            </div>
            <div class="col">
                <h2>Déclarant</h2>
                <?php
                $declarant = new \Belgian_Tax\XML\Declarant();
                $declarant->input();
                ?>
            </div>


        </div>
        <?php echo \HtmlInput::submit("save_misc","Sauver")?>
    </div>

<div style="display:<?=$display?>" class="p-2" id="opout">
<h1><?php echo _("Opération à la sortie");?></h1>
<?php $tab="opout";?>
<?php echo show("GRIL00",_("Grille 00 : opérations soumises à un régime particulier"))?>
<?php echo show("GRIL01",_("Grille 01 : Opérations pour lesquelles la TVA est due (6%)"))?>
<?php echo show("GRIL02",_("Grille 02 : Opérations pour lesquelles la TVA est due (12%)"))?>
<?php echo show("GRIL03",_("Grille 03 : Opérations pour lesquelles la TVA est due (21%)"))?>
<?php echo show("GRIL44",_("Grille 44 : Opérations pour lesquelles la TVA étrangère est due par le cocontractant"))?>
<?php echo show("GRIL45",_("Grille 45 : Opérations pour lesquelles la TVA est due par le cocontractant"))?>
<?php echo show("GRIL46",_("Grille 46 : Livraisons intracommunautaires exemptées effectuées en Belgique et ventes ABC"))?>
<?php echo show("GRIL47",_("Grille 47 :Autres opérations exemptées et autres opérations effectuées à l’étranger"))?>
<?php echo show("GRIL48",_("Grille 48 : Opérations relatives aux notes de crédit des grilles 44 et 48"))?>
<?php echo show("GRIL49",_("Grille 49 : Opérations relatives aux notes de crédit"))?>
</div>
<div media="screen" style="display:<?=$display?>" id="opin"  class="p-2">
	<?php $tab="opin";?>
<h1><?php echo _("Opération à l'entrée");?></h1>
<?php echo show("GRIL81",_("Grille 81 : Opération sur les marchandises, matières premières..."))?>
<?php echo show("GRIL82",_("Grille 82 : Opération sur les services et biens divers"))?>
<?php echo show("GRIL83",_("Grille 83 : Opération sur les biens d'investissements"))?>
<?php echo show("GRIL84",_("Grille 84 : Montant des notes de crédit reçues et des corrections négatives relatif aux opérations inscrites en grilles 86 et 88"))?>
<?php echo show("GRIL85",_("Grille 85 : Montant des notes de crédit reçues et des corrections négatives relatif aux autres opérations du cadre III  "))?>
<?php echo show("GRIL86",_("Grille 86 : Acquisitions intracommunautaires effectuées en Belgique et ventes ABC  "))?>
<?php echo show("GRIL87",_(" Autres opérations à l'entrée pour lesquelles la T.V.A. est due par le déclarant "))?>
<?php echo show("GRIL88",_("Services intracommunautaires avec report de perception"))?>
</div>
<div style="display:<?=$display?>" id="tvadue"  class="p-2">
<?php $tab="tvadue";?>
<h1><?php echo _("TVA Due");?></h1>
<?php echo show("GRIL54",_("Grille 54 : tva due sur opération grille 01,02 et 03"))?>
<?php echo show("GRIL55",_("Grille 55 : tva due sur opération grille 86 et 88"))?>
<?php echo show("GRIL56",_("Grille 56 : tva due sur opération grille 87"))?>
<?php echo show("GRIL57",_("Grille 57 :T.V.A. relative aux importations avec report de perception "))?>
<?php echo show("GRIL61",_("Grille 61 :Diverses régularisations T.V.A. en faveur de l'Etat"))?>
<?php echo show("GRIL63",_("Grille 63 :T.V.A. à reverser mentionnée sur les notes de crédit reçues"))?>
</div>
<div style="display:<?=$display?>" id="tvaded"  class="p-2" >
	<?php $tab="tvaded";?>
<h1> <?php echo _("TVA Déductible");?></h1>
<?php echo show("GRIL59",_("Grille 59 : taxe déductible"))?>
<?php echo show("GRIL62",_("Grille 62 : Diverses régularisations T.V.A. en faveur du déclarant"))?>
<?php echo show("GRIL64",_("Grille 56 : T.V.A. à récupérer mentionnée sur les notes de crédit délivrées "))?>
</div>
<div style="display:<?=$display?>" id="divers">
	<?php $tab="divers";?>
<fieldset>
<legend><?php echo _('Divers')?></legend>


<TABLE class="result">
<TR>
	<TH><?php echo _('Poste comptable')?></TH>
	<TH><?php echo _('Description')?></TH>
	<th></th>
</TR>
<TR>

	<TD>
	<?php 
	$atva=$cn->get_value("select pcm_val from tva_belge.parameter_chld where pcode='ATVA'");
	$ip_tva=new IPoste('ATVA',$atva);
	$ip_tva->set_attribute('gDossier',\Dossier::id());
	$ip_tva->set_attribute('jrn',0);
	$ip_tva->set_attribute('account','ATVA');
	$ip_tva->set_attribute('label','ATVA_label');
	echo $ip_tva->input();
	$lib=$cn->get_value("select pcm_lib from tmp_pcmn where pcm_val=$1",array($atva));
	?>
	</TD>
	<TD>
		<SPAN ID="ATVA_label"><?php echo h($lib)?></SPAN>
	</td>
	<?php echo td(_("Poste comptable utilisé pour les avances faites à la TVA"))?>
</tr>
<TR>
	<TD>
	<?php 
	$crtva=$cn->get_value("select pcm_val from tva_belge.parameter_chld where pcode='CRTVA'");
	$ip_tva=new IPoste('CRTVA',$crtva);
	$ip_tva->set_attribute('gDossier',\Dossier::id());
	$ip_tva->set_attribute('jrn',0);
	$ip_tva->set_attribute('account','CRTVA');
	$ip_tva->set_attribute('label','CRTVA_label');
	echo $ip_tva->input();
	$lib=$cn->get_value("select pcm_lib from tmp_pcmn where pcm_val=$1",array($crtva));
	?>
	</TD>
	<TD>
		<SPAN ID="CRTVA_label"><?php echo h($lib)?></SPAN>
	</td>
<?php echo td(("Poste comptable utilisé pour les créances sur la  TVA"))?>
</tr>
<TR>
<TD>
	<?php 
	$dttva=$cn->get_value("select pcm_val from tva_belge.parameter_chld where pcode='DTTVA'");
	$ip_tva=new IPoste('DTTVA',$dttva);
	$ip_tva->set_attribute('gDossier',\Dossier::id());
	$ip_tva->set_attribute('jrn',0);
	$ip_tva->set_attribute('account','DTTVA');
	$ip_tva->set_attribute('label','DTTVA_label');
	echo $ip_tva->input();
	$lib=$cn->get_value("select pcm_lib from tmp_pcmn where pcm_val=$1",array($dttva));
	?>
	</TD>
	<TD>
		<SPAN ID="DTTVA_label"><?php echo h($lib)?></SPAN>
	</td>
	<?php echo td(_("Poste comptable utilisé pour les dettes envers la TVA"))?>
</tr>

</TABLE>
	<?php echo \HtmlInput::submit("save_misc","Sauver")?>
</fieldset>
</div>

<?php
/**************************************************************************
 * Code and case VAT
 *************************************************************************/
?>
<div id="code_grille">
    <?php
$tab="code_grille";
?>
<h1><?=_('Code et grille TVA')?></h1>
    <?php
    // SQL to find out all TVA_RATE + VAT form Case +  ledger + Accounting
    $sql="
select tr.tva_id,tr.tva_rate,tr.tva_code,tr.tva_label,pc.pcode,pc.pcm_val,jd.jrn_def_name,jd.jrn_def_type,
       pc.p_side,
       pc.p_operation,
       pc.filter_ledger
from 
tva_rate tr
join tva_belge.parameter_chld pc on pc.tva_id=tr.tva_id 
left join jrn_def jd on (jd.jrn_def_id=pc.ledger_id)
where 
pc.pcode like 'GRI%'
order by pc.pcode ,tr.tva_id
    ";
    echo \HtmlInput::filter_table('code_grille_table', '0,1,2,3,4,5,6',1);
    $aSide=['P'=>'Positif','N'=>'Négatif'];
    $aOperation=['A'=>'Addition','S'=>'Soustrait'];
    ?>
    <table class="sortable result" id="code_grille_table">
        <tr>
            <th>ID</th>
            <th>Code</th>
            <th>Label</th>
            <th>Taux</th>
            <th class=" sorttable_sorted_reverse">Grille</th>
            <th>Signe</th>
            <th>Opération</th>
            <th>filtre journal</th>
            <th>filtre poste comptable</th>

        </tr>
        <?php
        // $aTva = contains result of $sql

        $aTva=$cn->get_array($sql);
        $nb_tva=count($aTva);
        for ($i=0;$i<$nb_tva;$i++):
            $class=($i%2==0)?' even ':'odd';
            ?>
            <tr class="<?=$class?>">
                <td><?=$aTva[$i]['tva_id']?></td>
                <td><?=$aTva[$i]['tva_code']?></td>
                <td><?=$aTva[$i]['tva_label']?></td>
                <td><?=$aTva[$i]['tva_rate']?></td>
                <td><?=$aTva[$i]['pcode']?></td>
                <td><?=$aSide[$aTva[$i]['p_side']]?></td>
                <td><?=$aOperation[$aTva[$i]['p_operation']]?></td>

                    <?php
                    switch ($aTva[$i]['filter_ledger']) {
                        case '1':
                            echo  td(\hi(_('Tous les journaux vente')));
                            break;
                        case '2':
                            echo td(\hi(_('Tous les journaux achat')));
                            break;
                        default:
                            echo td(\hb($aTva[$i]['jrn_def_name']));
                    }
                    ?>

                <td><?=$aTva[$i]['pcm_val']?></td>
            </tr>
        <?php
        endfor;

        ?>
    </table>
</div>
    <div id="summary_vat">
        <?php
$tab="summary_vat";
?>
<h1><?=_('Résumé formulaire TVA')?></h1>
    <?php
    // SQL fetch the form
    $aForm=$cn->get_array(
            "select fd_label,fd_type,pcode,fd_tva_code
            from
                tva_belge.form_detail
            left join tva_belge.parameter p on (replace(fd_tva_code,'d','GRIL')=p.pcode)
            where id > 9 order by id");
    $nb_form=count($aForm);
    for ($e=0;$e < $nb_form;$e++) :
        ob_start();
        if ( $aForm[$e]['fd_type']=='h2') :
            echo '<h3>';
            echo ($aForm[$e]['fd_label']);
            echo '</h3>';
         elseif ($aForm[$e]['fd_type']=='h1') :
            echo h2($aForm[$e]['fd_label']);
         endif;

        if ($aForm[$e]['fd_type']=='t' || preg_match('/d[0-9]{2}/', $aForm[$e]['fd_tva_code']) !== false) :
            $margin= (strpos("x".$aForm[$e]['fd_label'],'|>')==1) ?"6rem":"3rem";
            echo '<span style="display:block;margin-left:'.$margin.'">';
            echo h($aForm[$e]['fd_label']);
            // SQL to find out all TVA_RATE + VAT form Case +  ledger + Accounting
            echo "</span>";

            $sql="
select tr.tva_id,tr.tva_rate,tr.tva_code,tr.tva_label,pc.pcode,pc.pcm_val,jd.jrn_def_name,jd.jrn_def_type,
       pc.p_side,
       pc.p_operation,
       pc.filter_ledger
from 
tva_rate tr
join tva_belge.parameter_chld pc on pc.tva_id=tr.tva_id 
left join jrn_def jd on (jd.jrn_def_id=pc.ledger_id)
where 
pc.pcode = $1
order by pc.pcode ,tr.tva_id
    ";
            $aTva=$cn->get_array($sql,[$aForm[$e]['pcode']]);
            $nb_tva=count($aTva);
            if ( $nb_tva==0) {
                ob_end_clean();
                continue;
            }
            ob_end_flush();
    echo \HtmlInput::filter_table('code_grille_table'.$aForm[$e]['pcode'], '0,1,2,3,4,5,6',1);
    ?>
    <table class="sortable result" id="code_grille_table<?=$aForm[$e]['pcode']?>">
        <tr>
            <th class=" sorttable_sorted_reverse">Grille</th>
            <th>ID</th>
            <th>Code</th>
            <th>Label</th>
            <th>Taux</th>
            <th>Signe</th>
            <th>Opération</th>
            <th>filtre journal</th>
            <th>filtre poste comptable</th>

        </tr>
        <?php
        // $aTva = contains result of $sql


        for ($i=0;$i<$nb_tva;$i++):
            $class=($i%2==0)?' even ':'odd';
            ?>
            <tr class="<?=$class?>">
                <td><?=$aTva[$i]['pcode']?></td>
                <td><?=$aTva[$i]['tva_id']?></td>
                <td><?=$aTva[$i]['tva_code']?></td>
                <td><?=$aTva[$i]['tva_label']?></td>
                <td><?=$aTva[$i]['tva_rate']?></td>
                <td><?=$aSide[$aTva[$i]['p_side']]?></td>
                <td><?=$aOperation[$aTva[$i]['p_operation']]?></td>

                    <?php
                    switch ($aTva[$i]['filter_ledger']) {
                    case '1':
                    echo  td(\hi(_('Tous les journaux vente')));
                    break;
                    case '2':
                    echo td(\hi(_('Tous les journaux achat')));
                    break;
                    default:
                    echo td(\hb($aTva[$i]['jrn_def_name']));
                    }
                    ?>

                <td><?=$aTva[$i]['pcm_val']?></td>
            </tr>
        <?php
        endfor;

        ?>
    </table>
   <?php
   endif; //fd_type==t
    endfor; // loop $e
    ?>
</div>
<?php
/**************************************************************************
*INTRACOMM
*************************************************************************/

?>
<div style="display:none" id="lintra">
	<?php $tab="lintra";?>
<fieldset><h1>Listing intracommunautaires</h1>
<?php echo show("CLINTRA",_("Code TVA pour clients  Intracommunataire (Service)"))?>
<?php echo show("CLINTRAGD",_("Code TVA pour clients  Intracommunataire (Livraison)"))?>
<?php echo show("CLINTRATR",_("Code TVA pour clients  Intracommunataire (Transport)"))?>
</fieldset>
</div>
	<div style="display:none" id="assujetti">
	<?php $tab="assujetti";?>
<fieldset><h1>Listing Client nationaux</h1>
<?php echo show("ASSUJETTI",_("Code TVA pour clients  nationaux"))?>
</fieldset>
</div>
    <div style="display:<?= $display ?>>" class="p-2" id="confg">
        <h1>Sauver - restaurer configuration</h1>
        <p class="text-muted">
            Ce menu vous permet de copier le paramétrage de cette extension dans un autre dossier. Il
            ne reprendra pas les informations de la section "Représentant - Déclarant"
        </p>
        <h2>Export</h2>
        <p>
            <?php
            $url="extension.raw.php?".http_build_query(array("gDossier"=>\Dossier::id()
                        , "ac"=>$http->request("ac")
                        ,"plugin_code"=>$http->request('plugin_code')
                        ,"op"=>"export_parameter"
                    )
                );
            ?>
            Exportation de votre configuration
        </p>
        <p>
            <a href="<?=$url?>" class="button" >Exporte</a>

        </p>
        <h2>Import</h2>
        <p>
           Effacera et remplacera la configuration actuelle de votre extension TVA à l'exception de la section "Déclarant-Représentant".
        </p>
            <a href="javascript:void()" class="button" onclick="$('tva_import_file').show()">Importe</a>
    </div>

	</form>
<script charset="UTF-8" lang="javascript">
	tva_show_param('<?php echo $tab_default?>');
	</script>

<div class="inner_box2" style="position:fixed;top:35%;display:none" id="tva_import_file">
    <?=\HtmlInput::title_box("Importation","tva_import_file","hide")?>
    <div class="p-1">
        <p>
           Effacera et remplacera la configuration actuelle de votre extension TVA à l'exception de la section "Déclarant-Représentant".
        </p>
    <form method="POST" enctype="multipart/form-data">
        <input type="file" name="import_tva">
        <?php
        echo \HtmlInput::array_to_hidden(['gDossier','ac','plugin_code'], $_REQUEST);
        if ( isset($_REQUEST['sa'])) echo \HtmlInput::hidden('sa',$http->request("sa"));
        echo \HtmlInput::hidden('sb','import_tva');
        ?>
        <ul class="aligned-block">
            <li>
                <?=\HtmlInput::submit('Import',"Import")?>
            </li>
            <li>
                <?=\HtmlInput::button_hide("tva_import_file")?>
            </li>
        </ul>
    </form>
    </div>
</div>
</div>
