<?php
/*
 *   This file is part of NOALYSS.
 *
 *   NOALYSS is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   NOALYSS is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with NOALYSS; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// Copyright Author Dany De Bontridder danydb@aevalys.eu 6/02/25
/*! 
 * \file
 * \brief show previous messages used in previous email for this listing_id
 */

if (!defined('ALLOWED')) {
    die ("not allowed");
}
/**
 * @var $http HttpInput inherited
 * @var $cn Database inherited
 */
try {
    //var $lc_id int listing_compute.lc_id
    $lc_id=$http->get('lc_id',"number");
    // var $div : string name of the dgbox
    $div=$http->get('boxid');

} catch (\Exception $e) {
    echo $e->getMessage();
    return ;
}

echo HtmlInput::title_box(_("Message sauvegardé"), $div);
$listing_id=$cn->get_value('select l_id from rapport_advanced.listing_compute where lc_id=$1',[$lc_id]);
$aMessage=$cn->get_array('select lm_id,lm_subject , lm_message from rapport_advanced.listing_mail_message 
where listing_id=$1',[$listing_id]);

if (count($aMessage) == 0 )
{
    echo '<span class="notice text-center d-block p-3">';
    echo _('Pas de message sauvegardé');
    echo '</span>';
    echo '<div style="text-align: center">';
    echo \HtmlInput::button_close($div);
    echo '</div>';
    return;
}
$nb_message=count($aMessage);
?>
<div class="flex">

    <?php for ($i=0;$i<$nb_message;$i++):?>
    <?php $message = $aMessage[$i]?>
    <div class="row" id="message<?=$message['lm_id']?>">

        <div class="col-3">
            <a href="javascript:void()" onclick="Noalyss_Listing_Message.load_previous(<?=$message['lm_id']?>)" class="line">
                <?=$message['lm_subject']?>
            </a>
        </div>

        <div class="col-8">
        <?=$message['lm_message']?>
        </div>
        <div>
            <?=\Icon_Action::trash(uniqid(),'Noalyss_Listing_Message.delete('.$message['lm_id'].')')?>
        </div>
    </div>

    <?php endfor;?>
</ol>
</div>
<?php
echo '<div style="text-align: center">';
echo \HtmlInput::button_close($div);
echo '</div>';
return;
?>
